"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantSetStats(ProtocolElement):
    """
    Variant statistics for a set of variants. The variants set can be
    contain a whole study, a cohort, a sample, a region, ...
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "filesCount",
        "filterCount",
        "qualityAvg",
        "qualityStdDev",
        "sampleCount",
        "tiTvRatio",
        "variantCount",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.metadata.VariantSetStats": opencb_2_9_3.VariantSetStats,
        }

    __slots__ = [
        "filesCount",
        "filterCount",
        "qualityAvg",
        "qualityStdDev",
        "sampleCount",
        "tiTvRatio",
        "variantCount",
        "biotypeCount",
        "chromosomeCount",
        "chromosomeDensity",
        "consequenceTypeCount",
        "genotypeCount",
        "typeCount",
    ]

    def __init__(
        self,
        filesCount,
        filterCount,
        qualityAvg,
        qualityStdDev,
        sampleCount,
        tiTvRatio,
        variantCount,
        biotypeCount=dict,
        chromosomeCount=dict,
        chromosomeDensity=dict,
        consequenceTypeCount=dict,
        genotypeCount=dict,
        typeCount=dict,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.VariantSetStats model.

        :param filesCount:
            Number of files in the variant set
        :type filesCount: int
        :param filterCount:
            The number of occurrences for each FILTER value in files from this
            set. Each file can contain more than one filter value
            (usually separated by ';').
        :type filterCount: dict[str, int]
        :param qualityAvg:
            Mean Quality for all the variants with quality
        :type qualityAvg: float
        :param qualityStdDev:
            Standard Deviation of the quality
        :type qualityStdDev: float
        :param sampleCount:
            Number of samples in the variant set
        :type sampleCount: int
        :param tiTvRatio:
            TiTvRatio = num. transitions / num. transversions
        :type tiTvRatio: float
        :param variantCount:
            Number of variants in the variant set
        :type variantCount: int
        :param biotypeCount:
            Variants count group by biotype. e.g. protein-coding, miRNA, lncRNA,
            ...
        :type biotypeCount: dict[str, int]
        :param chromosomeCount:
            Number of variants per chromosome
        :type chromosomeCount: dict[str, int]
        :param chromosomeDensity:
            Total density of variants within the chromosome. counts /
            chromosome.length
        :type chromosomeDensity: dict[str, float]
        :param consequenceTypeCount:
            Variants count group by consequence type. e.g. synonymous_variant,
            missense_variant, stop_lost, ...
        :type consequenceTypeCount: dict[str, int]
        :param genotypeCount:
            Number of genotypes found for all samples in variants set
        :type genotypeCount: dict[str, int]
        :param typeCount:
            Variants count group by type. e.g. SNP, INDEL, MNP, SNV, ...
        :type typeCount: dict[str, int]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
